// ==UserScript==
// @name         B站助手
// @namespace    https://blog.imyqs.com/
// @version      0.3.0
// @description  一键下载B站的视频封面；一键下载B站的电影海报。
// @author       FrankYu
// @match        *://www.bilibili.com/video/*
// @match        *://www.bilibili.com/bangumi/play/*
// @require      https://cdn.staticfile.org/jquery/3.4.1/jquery.min.js
// @grant        GM_download
// @grant        GM_notification
// @license      CC by-4.0
// @run-at       document-idle
// ==/UserScript==

(function () {
    'use strict';
    // 获取当前网页 URL
    var URL = window.location.href;

    /**
    * 0. 视频标题
    * 1. 视频标题_UP主
    * 2. UP主_视频标题
    * 3. 视频标题_UP主_分区
    * 4. 视频标题_分区_UP主
    * 5. UP主_视频标题_分区
    * 6. UP主_分区_视频标题
    * 7. 分区_UP主_视频标题
    * 8. 分区_视频标题_UP主
    */
    var video_Name_Type = 0;                    //下载的封面标题不同格式，默认为0，即只有视频名称，用户可自行修改
    var video_Name_Download = '';               //下载的封面标题名称

    var global_Download_URL = '';               //全局使用下载地址
    var global_Download_File_Name = '';         //全局使用下载文件名称

    if (URL.indexOf('video') != -1) {
        var v_pic = vd.pic;                 //视频封面地址
        var v_title = vd.title;             //标题
        var v_author = vd.owner.name;       //UP主
        var v_type = vd.tname;              //分区
        var v_suffix = vd.pic.split('.')[vd.pic.split('.').length - 1]; //视频封面后缀，jpg/png

        //下载文件名称可选
        switch (video_Name_Type) {
            case 0:
                video_Name_Download = v_title;
                break;
            case 1:
                video_Name_Download = v_title + '_' + v_author;
                break;
            case 2:
                video_Name_Download = v_author + '_' + v_title;
                break;
            case 3:
                video_Name_Download = v_title + '_' + v_author + '_' + v_type;
                break;
            case 4:
                video_Name_Download = v_title + '_' + v_type + '_' + v_author;
                break;
            case 5:
                video_Name_Download = v_author + '_' + v_title + '_' + v_type;
                break;
            case 6:
                video_Name_Download = v_author + '_' + v_type + '_' + v_title;
                break;
            case 7:
                video_Name_Download = v_type + '_' + v_author + '_' + v_title;
                break;
            case 8:
                video_Name_Download = v_type + '_' + v_title + '_' + v_author;
                break;
            default:
                console.log('视频名称类型错误')
                break;
        }

        //添加下载按钮
        $("body").append('<div id="down_pic" style="position:fixed;z-index:999;background-color:#00A4D7;cursor:pointer;top:40%;left:0px;border:#00A4D7 1px;border-top-right-radius:5px;border-bottom-right-radius:5px;">'
            + '<div style="font-size:12px;font-weight:bolder;padding:8px 2px;color:cornsilk;">'
            + '下载<br>封面'
            + '</div></div>');

        $("body").on("click", "#down_pic", function () {
            global_Download_URL = v_pic;   //获取下载链接
            global_Download_File_Name = video_Name_Download + '.' + v_suffix;   //获取下载文件的后缀
            download_Pic();
        });

        $('#reco_list').click(function (e) {
            location.reload();
        });

    } else if (URL.indexOf('bangumi/play') != -1) {
        //定义
        var m_pic;
        var m_poster;
        var m_title;
        var m_pic_suffix;
        var m_poster_suffix;

        /*每秒检测两次是否可以下载，如果可以下载则开启下载并停止检测 */
        var Detect_Download = setInterval(function () {
            if (typeof (md.cover) != "string") {
                console.log('暂时不能下载');
            } else {
                console.log('当前可以下载');
                kill_interval()     //停止检测
            }
        }, 500)

        // 停止检测
        function kill_interval() {
            clearInterval(Detect_Download);
            extend_start();     //开启下载模块
        }

        // 获取信息
        function get_Movie_info() {
            m_poster = md.cover;        //电影海报链接
            m_title = md.title;         //电影名称

            //海报文件后缀
            m_poster_suffix = m_poster.split('.')[m_poster.split('.').length - 1]
        }

        function extend_start() {

            get_Movie_info();

            //添加下载按钮
            $("body").append('');
            $("body").append('<div style="position:fixed;z-index:999;background-color:#00A4D7;cursor:pointer;top:40%;left:0px;border:#00A4D7 1px;border-top-right-radius:5px;border-bottom-right-radius:5px;">'
                + '<div id="down_poster" style="font-size:12px;font-weight:bolder;padding:8px 2px;color:cornsilk;">'
                + '下载<br>海报'
                + '</div></div>');

            //下载海报
            $("body").on("click", "#down_poster", function () {
                global_Download_URL = 'https:' + m_poster;   //获取下载链接
                global_Download_File_Name = m_title + '_海报.' + m_poster_suffix;
                download_Pic();
            });

            $('.plp-r').click(function (e) {
                console.log('点击右侧一次');
                setTimeout(function () {
                    get_Movie_info();
                }, 1000);

            });

        }
    } else {
        //其他功能待定。
    }

    // 下载函数
    function download_Pic() {
        GM_download({
            url: global_Download_URL,
            name: global_Download_File_Name,
            saveAs: true,
            onload() {
                GM_notification('图片：“ ' + global_Download_File_Name + ' ”  下载成功~');
            },
            onerror(e) {
                GM_notification('下载失败。')
                console.log("下载失败，失败原因：");
                console.log(e);
            }
        })
    }

    // Your code here...
})();

